/* bin_open - open a binary file 
 * WSL 2.3 version
 */
#include "bin_io.h"
bin_fd bin_open(fname, type)
	char fname[];
	int type;
	{
	int fd;

	if ((type & O_TRUNC) != O_TRUNC)	/* not TRUNC mode */
		{
		fd = open(fname, type & O_RWMODE, 1);		/* attempt open */
		if (fd >= 0)
			{
			if ((type & (O_EXCL|O_CREAT)) == (O_EXCL|O_CREAT))
				return (-1);			/* not allowed to exist */
			else
				return (fd);			/* open succeeded */
			}
		else if ((type & O_RWMODE) == O_RDONLY)
			return (fd);				/* rdonly, open failed */
		}
	if ((type & O_CREAT) != O_CREAT)
		return (-1);					/* not allowed to create */
	fd = create(fname, type & O_RWMODE, 1);		/* attempt create */
	return (fd);
	}
